-- Exercises 3. Laziness.

-- Repeat a value infinitely many times
repeat' :: a -> [a]
repeat' a = a : repeat' a

-- Repeat recursive call infinitely many times and save all intermidiate results: [a, f a, f (f a), f (f (f a)), ...]
iterate' :: (a -> a) -> a -> [a]
iterate' f a = a : iterate' f (f a)

-- Define a list of all natural numbers: 0, 1, 2, 3, 4, ...
numbers :: [Int]
numbers = iterate' (+ 1) 0

--Define a list of all even numbers: 0, 2, 4, 6, 8, ...
evens :: [Int]
evens = iterate' (+ 2) 0

-- Define a list of all squared numbers: 0, 1, 4, 9, 16, ...
squares :: [Int]
squares = map (^ 2) numbers

-- Implement Fibonacci sequence as an infinite list
fib :: [Int]
fib = 0 : 1 : zipWith (+) fib (tail fib)

-- Define an unbounded search operator mu: a function, which returns minimal natural number with the given property
mu :: (Int -> Bool) -> Int
mu f = snd $ head (filter fst (zip (map f numbers) numbers))

-- mu f = head (filter f numbers)

-- Define an unbounded search operator mu': a function, which returns all natural numbers with the given property
mu' :: (Int -> Bool) -> [Int]
mu' f = map snd (filter fst (zip (map f numbers) numbers))

-- mu' f = filter f numbers

-- Define a bounded search operator mu''. Same as mu', but numbers are bounded from top.
mu'' :: (Int -> Bool) -> Int -> [Int]
mu'' f b =
  let numbers' = take b numbers
   in map snd (filter fst (zip (map f numbers') numbers'))

-- mu'' f b =  filter f (take b numbers)

-- Define a list of all prime numbers: 2, 3, 5, 7, 11, 13, ...
primes :: [Int]
primes = tail $ map snd (filter (not . fst) $ zip cond numbers)
  where
    multiples = map (\x -> map (* x) numbers) numbers
    divs = map tail (tail (multiples))
    useful_divs = zipWith take numbers divs
    cond = map (\x -> or $ map (elem x) (take x useful_divs)) numbers

-- Executes sum (take 100000 primes) in 8.4 sec
-- primes = 2 : 3 : filter isPrime [5, 7..]
-- isPrime n = all (\p -> mod n p /= 0) (takeWhile (\p -> p*p <= n) primes)
